'
'QFImage.inc, rev1.3
'- bug fixed: while loading, the image was not copied from qfimage.image.BMP to qfimage.BMP - sry!
'- direct memory copy a FreeImage-Bitmap into a RapidQ-Image - experimental!
'- memory functions for FreeImage.dll added
'
'A Mini(!)-Wrapper for using with FreeImage.dll (actual version is 3.9.1)
'FreeImage is an Open Source library project for developers who would like to support popular graphics image formats.
'FreeImage was designed and mainly developed by Floris van den Berg. FreeImage is now maintained by Herv Drolon.
'Download and project site: http://freeimage.sourceforge.net/
' 
'QFImage.inc, (c)07/2006 by StoneCold (Christian Tandler), stonecold@sctools.de
'
'Based on:
'Visual Basic Wrapper for FreeImage 3
'Original FreeImage 3 functions and VB compatible derived functions
'Design and implementation by Carsten Klein (cklein05@users.sourceforge.net)
'
'
'Why this wrapper?
'Several months ago i'm searching for my RapidQ projects for a DLL wich supports some basicly image functions.
'Not too complicated, but, only load and save are not enough for me ;-)
'So i've looked for a free image library like NViewLib.dll (only load and save) or CxImage.dll - many functions
'but not exported in the DLL for using with VB or must be registered as OCX-Version...
'Also, a lot of commercial libraries on market, but, you must pay for it and these things are a little too big for me ;-)
'Now, the FreeImage.dll seems to be the right thing - a free, fast, uncomplicated library with many functions....
'So i think, FreeImage.dll is the right partner for RapidQ ;-)
'
'I've wrapped some of the fundamental functions into this QFImage-Object for RapidQ.
'Hope, you'll like it ;-)
'
'btw: If you pack the FreeImage.dll with an EXE-Packer like (free) UPX, you can downsize the DLL for more of a half
'to make your distribution smaller!
'
'
'This file contains 2 RapidQ-Ojects:
'
' QFImage    - the standard object, does not handle animated GIF's (only the 1.st frame)
' QFGifImage - handles animated GIF's, but only read functions and no resize and so on...
'
'
'This code is freeware - use it at your own risk and edit it in your own opinion if you like it.
'Only, let the Copyright inside - Thx!
'Greetz
'StoneCold   


$ifndef __QFIMAGE
  $define __QFIMAGE
$endif

'for testing purpose
'uncomment for not killing the tmp-file
'$define _QFI_TEST

'Set the max. frames for animated Gif's, 128 should be enough in most cases
Const GIF_MAX_FRAMES = 128

'FreeImage Load-/Save Constants
Const FI_LOAD_PROP = -1
Const FI_SAVE_PROP = -1
Const BMP_DEFAULT = 0
Const BMP_SAVE_RLE = 1
Const CUT_DEFAULT = 0
Const DDS_DEFAULT = 0
Const GIF_DEFAULT = 0
Const GIF_LOAD256 = 1              ' Load the image as a 256 color image with ununsed palette entries, if it's 16 or 2 color
Const GIF_PLAYBACK = 2             ''Play' the GIF to generate each frame (as 32bpp) instead of returning raw frame data when loading
Const HDR_DEFAULT = 0
Const ICO_DEFAULT = 0
Const ICO_MAKEALPHA = 1            ' convert to 32bpp and create an alpha channel from the AND-mask when loading
Const IFF_DEFAULT = 0
Const JPEG_DEFAULT = 0
Const JPEG_FAST = 1
Const JPEG_ACCURATE = 2
Const JPEG_QUALITYSUPERB = &H80
Const JPEG_QUALITYGOOD = &H100
Const JPEG_QUALITYNORMAL = &H200
Const JPEG_QUALITYAVERAGE = &H400
Const JPEG_QUALITYBAD = &H800
Const JPEG_CMYK = &H1000           ' load separated CMYK "as is" (use 'OR' to combine with other flags)
Const KOALA_DEFAULT = 0
Const LBM_DEFAULT = 0
Const MNG_DEFAULT = 0
Const PCD_DEFAULT = 0
Const PCD_BASE = 1                 ' load the bitmap sized 768 x 512
Const PCD_BASEDIV4 = 2             ' load the bitmap sized 384 x 256
Const PCD_BASEDIV16 = 3            ' load the bitmap sized 192 x 128
Const PCX_DEFAULT = 0
Const PNG_DEFAULT = 0
Const PNG_IGNOREGAMMA = 1          ' avoid gamma correction
Const PNM_DEFAULT = 0
Const PNM_SAVE_RAW = 0             ' if set the writer saves in RAW format (i.e. P4, P5 or P6)
Const PNM_SAVE_ASCII = 1           ' if set the writer saves in ASCII format (i.e. P1, P2 or P3)
Const PSD_DEFAULT = 0
Const RAS_DEFAULT = 0
Const TARGA_DEFAULT = 0
Const TARGA_LOAD_RGB888 = 1        ' if set the loader converts RGB555 and ARGB8888 -> RGB888
Const TIFF_DEFAULT = 0
Const TIFF_CMYK = &H1              ' reads/stores tags for separated CMYK (use 'OR' to combine with compression flags)
Const TIFF_PACKBITS = &H100        ' save using PACKBITS compression
Const TIFF_DEFLATE = &H200         ' save using DEFLATE compression (a.k.a. ZLIB compression)
Const TIFF_ADOBE_DEFLATE = &H400   ' save using ADOBE DEFLATE compression
Const TIFF_NONE = &H800            ' save without any compression
Const TIFF_CCITTFAX3 = &H1000      ' save using CCITT Group 3 fax encoding
Const TIFF_CCITTFAX4 = &H2000      ' save using CCITT Group 4 fax encoding
Const TIFF_LZW = &H4000            ' save using LZW compression
Const TIFF_JPEG = &H8000           ' save using JPEG compression
Const WBMP_DEFAULT = 0
Const XBM_DEFAULT = 0
Const XPM_DEFAULT = 0

'FreeImage File-Formats (here: Types)
Const FIF_UNKNOWN = -1
Const FIF_BMP = 0
Const FIF_ICO = 1
Const FIF_JPEG = 2
Const FIF_JNG = 3
Const FIF_KOALA = 4
Const FIF_IFF = 5
Const FIF_LBM = FIF_IFF
Const FIF_MNG = 6
Const FIF_PBM = 7
Const FIF_PBMRAW = 8
Const FIF_PCD = 9
Const FIF_PCX = 10
Const FIF_PGM = 11
Const FIF_PGMRAW = 12
Const FIF_PNG = 13
Const FIF_PPM = 14
Const FIF_PPMRAW = 15
Const FIF_RAS = 16
Const FIF_TARGA = 17
Const FIF_TIFF = 18
Const FIF_WBMP = 19
Const FIF_PSD = 20
Const FIF_CUT = 21
Const FIF_XBM = 22
Const FIF_XPM = 23
Const FIF_DDS = 24
Const FIF_GIF = 25
Const FIF_HDR = 26
Const FIF_FAXG3 = 27
Const FIF_SGI = 28

'FreeImage Format-Strings
Const FIF_STR_UNKNOWN = "Unknown"
Const FIF_STR_BMP = "Windows/OS2 Bitmap (BMP)"
Const FIF_STR_GIF = "CompuServe Graphics Interchange (GIF)"
Const FIF_STR_JPEG = "Independent JPEG/JFIF (JPG)"
Const FIF_STR_JNG = "JPEG Network Graphics (JNG)"
Const FIF_STR_PNG = "Portable Network Graphics (PNG)"
Const FIF_STR_ICO = "Icon (ICO)"
Const FIF_STR_TARGA = "Truevision Targa (TGA)"
Const FIF_STR_TIFF = "Tagged Image File (TIF)"
Const FIF_STR_PCX = "Zsoft Paintbrush (PCX)"
Const FIF_STR_IFF = "Amiga/Deluxe Paint (IFF/LBM)"
Const FIF_STR_LBM = FIF_STR_IFF
Const FIF_STR_MNG = "Multiple Network Graphics (MNG)"
Const FIF_STR_PBM = "Portable Bitmap (PBM)"
Const FIF_STR_PGM = "Portable Greymap (PGM)"
Const FIF_STR_PPM = "Portable Pixelmap (PPM)"
Const FIF_STR_RAS = "Sun Raster Picture (RAS)"
Const FIF_STR_WBMP = "Wireless Bitmap (WBMP)"
Const FIF_STR_PSD = "Photoshop Image (PSD)"
Const FIF_STR_CUT = "Dr. Halo (CUT)"
Const FIF_STR_XBM = "X Windows Bitmap (XBM)"
Const FIF_STR_XPM = "X Windows Pixmap (XPM)"
Const FIF_STR_DDS = "DirectDraw Surface (DDS)"
Const FIF_STR_FAXG3 = "FAX Group 3 (G3)"
Const FIF_STR_SGI = "Silicon Graphics Image (SGI)"

'FreeImage Filter for resizing
Const FI_FILTER_BOX = 0
Const FI_FILTER_PIX = 0
Const FI_FILTER_BICUBIC = 1
Const FI_FILTER_BILINEAR = 2
Const FI_FILTER_BSPLINE = 3
Const FI_FILTER_CATMULLROM = 4
Const FI_FILTER_LANCZOS3 = 5

'FreeImage Quantize Options
Const FIQ_WUQUANT = 0        'Xiaolin Wu color quantization algorithm
Const FIQ_NNQUANT = 1        'NeuQuant neural-net quantization algorithm by Anthony Dekker

'Flip options
Const FI_FLIP_VER = 0
Const FI_FLIP_HOR = 1

'Adjust options
Const FI_ADJ_GAMMA = 0
Const FI_ADJ_BRIGHT = 1
Const FI_ADJ_CONTRAST = 2

'Convert options
Const FI_CONV_GREY = 0
Const FI_CONV_4BIT = 1
Const FI_CONV_8BIT = 2
Const FI_CONV_16BIT = 3
Const FI_CONV_24BIT = 4
Const FI_CONV_32BIT = 5


'--------------------------------------------------------------------------------
' FreeImage 3 function wrapper
'--------------------------------------------------------------------------------
'This is just a very small basic part of all FreeImage functions!
'All FreeImage 3 functions are described in the FreeImage 3 API documentation
'and especially the VB-Wrapper examples.
'Please see there for further details of these and many others functions.

'fif : FImage fileformats (FIF_...)
'dib : FImage handle
'Flags : FImage load/save options
'Filter : FImage filter
'quantize : Quantize method for reducing bpp

'General functions
Declare Function FI_GetVersion Lib "FreeImage.dll" Alias "_FreeImage_GetVersion@0" () As String
Declare Function FI_GetCopyright Lib "FreeImage.dll" Alias "_FreeImage_GetCopyrightMessage@0" () As String

'Info functions
Declare Function FI_GetBPP Lib "FreeImage.dll" Alias "_FreeImage_GetBPP@4" (ByVal dib As Long) As Long
Declare Function FI_GetWidth Lib "FreeImage.dll" Alias "_FreeImage_GetWidth@4" (ByVal dib As Long) As Long
Declare Function FI_GetHeight Lib "FreeImage.dll" Alias "_FreeImage_GetHeight@4" (ByVal dib As Long) As Long
Declare Function FI_GetSize Lib "FreeImage.dll" Alias "_FreeImage_GetDIBSize@4" (ByVal dib As Long) As Long

'Load and save functions
Declare Function FI_LoadImage Lib "FreeImage.dll" Alias "_FreeImage_Load@12" ( ByVal fif As Long, ByVal Filename As String, ByVal Flags As Long ) As Long
Declare Function FI_SaveImage Lib "FreeImage.dll" Alias "_FreeImage_Save@16" ( ByVal fif As Long, ByVal dib As Long, ByVal Filename As String, ByVal Flags As Long) As Long

'Conversion functions
Declare Function FI_ConvToGrey Lib "FreeImage.dll" Alias "_FreeImage_ConvertToGreyscale@4" ( ByVal dib As Long) As Long
Declare Function FI_ConvTo4Bit Lib "FreeImage.dll" Alias "_FreeImage_ConvertTo4Bits@4" ( ByVal dib As Long) As Long
Declare Function FI_ConvTo8Bit Lib "FreeImage.dll" Alias "_FreeImage_ConvertTo8Bits@4" ( ByVal dib As Long) As Long
Declare Function FI_ConvTo16Bit Lib "FreeImage.dll" Alias "_FreeImage_ConvertTo16Bits555@4" ( ByVal dib As Long) As Long
Declare Function FI_ConvTo24Bit Lib "FreeImage.dll" Alias "_FreeImage_ConvertTo24Bits@4" ( ByVal dib As Long) As Long
Declare Function FI_ConvTo32Bit Lib "FreeImage.dll" Alias "_FreeImage_ConvertTo32Bits@4" ( ByVal dib As Long) As Long

'Upsampling and downsampling
Declare Function FI_Resize Lib "FreeImage.dll" Alias "_FreeImage_Rescale@16" ( ByVal dib As Long, ByVal dst_width As Long, ByVal dst_height As Long, ByVal Filter As Long) As Long
Declare Function FI_ReduceColor Lib "FreeImage.dll" Alias "_FreeImage_ColorQuantize@8" (ByVal dib As Long, ByVal quantize As Long) As Long

'Flip and rotating functions
Declare Function FI_FlipHorizontal Lib "FreeImage.dll" Alias "_FreeImage_FlipHorizontal@4" (ByVal dib As Long) As Long
Declare Function FI_FlipVertical Lib "FreeImage.dll" Alias "_FreeImage_FlipVertical@4" (ByVal dib As Long) As Long
Declare Function FI_Rotate Lib "FreeImage.dll" Alias "_FreeImage_RotateClassic@12" (ByVal dib As Long, ByVal angle As Double) As Long

'Global adjust functions
Declare Function FI_AdjustGamma Lib "FreeImage.dll" Alias "_FreeImage_AdjustGamma@12" (ByVal dib As Long, ByVal gamma As Double) As Long
Declare Function FI_AdjustBrightness Lib "FreeImage.dll" Alias "_FreeImage_AdjustBrightness@12" (ByVal dib As Long, ByVal percentage As Double) As Long
Declare Function FI_AdjustContrast Lib "FreeImage.dll" Alias "_FreeImage_AdjustContrast@12" (ByVal dib As Long, ByVal percentage As Double) As Long
Declare Function FI_Invert Lib "FreeImage.dll" Alias "_FreeImage_Invert@4" (ByVal dib As Long) As Long

'Copy (Crop) & paste parts of an image
Declare Function FI_Copy Lib "FreeImage.dll" Alias "_FreeImage_Copy@20" (ByVal dib As Long, ByVal left As Long, ByVal top As Long, ByVal right As Long, ByVal bottom As Long) As Long
Declare Function FI_Paste Lib "FreeImage.dll" Alias "_FreeImage_Paste@20" (ByVal dstdib As Long, ByVal srcdib As Long, ByVal left As Long, ByVal top As Long, ByVal alpha As Long) As Long

'Freeing the image
Declare Sub FI_UnloadImage Lib "FreeImage.dll" Alias "_FreeImage_Unload@4" (ByVal dib As Long)

'Multipage bitmap support (at this time only read and only GIF for the type QFGifImage!)
Declare Function FI_OpenMultiBitmap Lib "FreeImage.dll" Alias "_FreeImage_OpenMultiBitmap@24" (ByVal fif As LONG, ByVal Filename As String, ByVal create_new As Long, ByVal read_only As Long, ByVal keep_cache_in_memory As Long, ByVal Flags As Long) As Long
Declare Function FI_CloseMultiBitmap Lib "FreeImage.dll" Alias "_FreeImage_CloseMultiBitmap@8" (ByVal mpdib As Long, ByVal Flags As Long) As Long
Declare Function FI_GetPageCount Lib "FreeImage.dll" Alias "_FreeImage_GetPageCount@4" (ByVal mpdib As Long) As Long
Declare Function FI_LockPage Lib "FreeImage.dll" Alias "_FreeImage_LockPage@8" (ByVal mpdib As Long, ByVal PageNum As Long) As Long
Declare Sub FI_UnlockPage Lib "FreeImage.dll" Alias "_FreeImage_UnlockPage@12" (ByVal mpdib As Long, ByVal PageHandle As Long, ByVal Changed As Long)

'Memory functions
Declare Function FI_OpenMemory Lib "FreeImage.dll" Alias "_FreeImage_OpenMemory@8" (ByVal IOFlag AS Integer, ByVal MemSize As Long) As Long
Declare Function FI_LoadFromMemory Lib "FreeImage.dll" Alias "_FreeImage_LoadFromMemory@12" (ByVal fif As Long, ByVal Stream As Long, ByVal Flags As Long) As Long
Declare Function FI_SaveToMemory Lib "FreeImage.dll" Alias "_FreeImage_SaveToMemory@16" (ByVal fif As Long, ByVal dib As Long, ByVal Stream As Long, Flags As Long) As Long
Declare Function FI_CloseMemory Lib "FreeImage.dll" Alias "_FreeImage_CloseMemory@4" (ByVal Stream As Long) As Long
Declare Function FI_ReadMemory Lib "FreeImage.dll" Alias "_FreeImage_ReadMemory@16" (ByRef Buffer As Long, ByVal Size As Long, ByVal Length As Long, ByVal Stream As Long) As Long
Declare Function FI_AcquireMemory Lib "FreeImage.dll" Alias "_FreeImage_AcquireMemory@12" (ByVal Stream As Long, ByRef Buffer As Long, ByRef Size As Long) As Long


'Now, it's RapidQ time ;-)
'Not all types are supported by FreeImage.dll for reading AND writing.
'
'QFImage:
'--------
'All public functions for QFImage are only modify the FI-Image given by the handle. This means:
'- the image is not loaded into the QFImage.Image.BMP
'- this increase the speed without several temporarly loading processes
'- prevents memory leaks, most FreeImage-Functions returning a copy of the original image
'- if after image processing the original image is not freed, you'll quickly run into memory problems...
'
'There's only one exception: GetImage()
'This function get the FI-Image via a harddisc TMP-File into the RapidQ-BMP from QFImage
'After this, you should destroy the FI-Image to free the memory!
'
'Example:
'
'dim myfimage as qfimage
'myfimage.LoadFromFile("test.jpg", FI_LOAD_PROP)      'load the JPG
'myfimage.ResizeImage(200, 200, FI_FILTER_BICUBIC)    'resize to 200*200 
'myfimage.ReduceColor(FIQ_WUQUANT)                    'reduce colors to 256
'myfimage.GetImage                                    'get the image into myfimage.image.bmp (do not forget!)
'myfimage.UnloadImage                                 'unload the FI-Image (don't forget, otherwise memory leaks!)
'
'
'If anyone find the method to copy an QFIMAGE 'directly' into the RapidQ-BMP,
'this would be cool - let me know ;-)
'Hey, i've found the solution - see function GetFastImage()!
'But i've a problem with copying the bitmap with CopyRect() into the image - why this!?
'If you'll test this function, use GetFastImage() unstead GetImage().
'
'
'QFGifImage:
'-----------
'- has Methods: .OpenFromFile, .IsAnimGIF, .StartAnim, .StopAnim and .SaveFrames
'- support only GIF's with GIF_MAX_PAGES (see on top)
'
'There are some problems with optimized GIF's they store not the whole frames but only the edited pixel
'At this time the position of such frames in 'mother-frame 0' are unknown...


'The Type QFImage
TYPE QFImage EXTENDS QIMAGE
private:
  Handle AS LONG
  
public:
  Image AS QIMAGE
  Width AS INTEGER
  Height AS INTEGER
  Size AS INTEGER
  Bpp AS INTEGER
  Colors AS INTEGER
  Type AS INTEGER
  TypeString AS STRING * 40
  LoadOption AS INTEGER
  SaveOption AS INTEGER


'Public functions
'GetImageType
'Get the image type of a given filename from the extension
'The type is returned and stored in QFImage...
'Not all FI-Types are supported.
FUNCTION GetImageType(sSourceFile AS STRING) AS INTEGER
  DIM sext AS STRING
  
  sext = UCase$(Field$(sSourceFile,".",2))
  if sext <> "" then
    select case sext
      case "BMP","DIB","RLE"
        qfimage.Type = FIF_BMP
        qfimage.TypeString = FIF_STR_BMP
      case "JPG","JPEG","JFI","JFIF"
        qfimage.Type = FIF_JPEG
        qfimage.TypeString = FIF_STR_JPEG
      case "GIF"
        qfimage.Type = FIF_GIF
        qfimage.TypeString = FIF_STR_GIF
      case "JNG"
        qfimage.Type = FIF_JNG
        qfimage.TypeString = FIF_STR_JNG
      case "PNG"
        qfimage.Type = FIF_PNG
        qfimage.TypeString = FIF_STR_PNG
      case "ICO"
        qfimage.Type = FIF_ICO
        qfimage.TypeString = FIF_STR_ICO
      case "TGA"
        qfimage.Type = FIF_TARGA
        qfimage.TypeString = FIF_STR_TARGA
      case "TIF","TIFF"
        qfimage.Type = FIF_TIFF
        qfimage.TypeString = FIF_STR_TIFF
      case "PCX"
        qfimage.Type = FIF_PCX
        qfimage.TypeString = FIF_STR_PCX
      case "IFF","LBM"
        qfimage.Type = FIF_IFF
        qfimage.TypeString = FIF_STR_IFF
      case "MNG"
        qfimage.Type = FIF_MNG
        qfimage.TypeString = FIF_STR_MNG
      case "PBM"
        qfimage.Type = FIF_PBM
        qfimage.TypeString = FIF_STR_PBM
      case "PGM"
        qfimage.Type = FIF_PGM
        qfimage.TypeString = FIF_STR_PGM
      case "PPM"
        qfimage.Type = FIF_PPM
        qfimage.TypeString = FIF_STR_PPM
      case "RAS"
        qfimage.Type = FIF_RAS
        qfimage.TypeString = FIF_STR_RAS
      case "SGI"
        qfimage.Type = FIF_SGI
        qfimage.TypeString = FIF_STR_SGI
      case "WAP","WBMP","WBM"
        qfimage.Type = FIF_WBMP
        qfimage.TypeString = FIF_STR_WBMP
      case "PSD"
        qfimage.Type = FIF_PSD
        qfimage.TypeString = FIF_STR_PSD
      case "CUT"
        qfimage.Type = FIF_CUT
        qfimage.TypeString = FIF_STR_CUT
      case "XPM"
        qfimage.Type = FIF_XPM
        qfimage.TypeString = FIF_STR_XPM
      case "XBM"
        qfimage.Type = FIF_XBM
        qfimage.TypeString = FIF_STR_XBM
      case "DDS"
        qfimage.Type = FIF_DDS
        qfimage.TypeString = FIF_STR_DDS
      case "G3"
        qfimage.Type = FIF_FAXG3
        qfimage.TypeString = FIF_STR_FAXG3
      case else
        qfimage.Type = FIF_BMP
        qfimage.TypeString = FIF_STR_BMP
    end select
  else
    qfimage.Type = FIF_BMP
    qfimage.TypeString = FIF_STR_BMP
  end if 
  qfimage.GetImageType = qfimage.Type
END FUNCTION

'LoadFromFile
'Loads an image file into the object
'The LoadOption is one of the defined open/save options and overwrite qfimage.LoadOption.
'If you wish to use the object property instead the function parameter you have set before, use FI_LOAD_PROP.
'Returns TRUE if OK, otherwise FALSE
FUNCTION LoadFromFile(sSourceFile AS STRING, iLoadOption AS INTEGER) AS INTEGER
  DIM sok AS INTEGER
  DIM lopt AS INTEGER
  DIM sext AS STRING
  
  qfimage.GetImageType(sSourceFile)
  if iLoadOption = FI_LOAD_PROP then
    lopt = qfimage.LoadOption
  else
    lopt = iLoadOption
  end if
  qfimage.Handle = FI_LoadImage(qfimage.Type, sSourceFile, lopt)
  if qfimage.Handle then
    qfimage.Width = FI_GetWidth(qfimage.Handle)
    qfimage.Height = FI_GetHeight(qfimage.Handle)
    qfimage.Size = FI_GetSize(qfimage.Handle)
    qfimage.Bpp = FI_GetBpp(qfimage.Handle)
    qfimage.Colors = 2^qfimage.Bpp
    qfimage.LoadFromFile = True
  else
    qfimage.LoadFromFile = False
  end if
END FUNCTION

'GetImage
'Loads the actual FI-Image from FI-Structure into qfimage.Image.BMP
'Returns TRUE if OK, otherwise FALSE
FUNCTION GetImage() AS INTEGER
  DIM sok AS INTEGER
  
  if qfimage.Handle then
    sok = FI_SaveImage(FIF_BMP, qfimage.Handle, "_FI_TMP_IMAGE_.BMP", BMP_DEFAULT)
    if sok then
      qfimage.Image.BMP = "_FI_TMP_IMAGE_.BMP"
      qfimage.BMP = qfimage.Image.BMP
      qfimage.Width = FI_GetWidth(qfimage.Handle)
      qfimage.Height = FI_GetHeight(qfimage.Handle)
      qfimage.Size = FI_GetSize(qfimage.Handle)
      qfimage.Bpp = FI_GetBpp(qfimage.Handle)
      qfimage.Colors = 2^qfimage.Bpp
      qfimage.GetImage = True
    else
      qfimage.GetImage = False
    end if
$ifndef _QFI_TEST
    Kill("_FI_TMP_IMAGE_.BMP")
$endif
  else
    qfimage.GetImage = False
  end if
END FUNCTION

'GetFastImage
'Loads the actual FI-Image from FI-Structure into qfimage.Image.BMP via Memory-Stream
'Returns TRUE if OK, otherwise FALSE
FUNCTION GetFastImage() AS INTEGER
  DIM fbmp AS QBITMAP
  DIM src AS QRECT
  DIM dest AS QRECT
  DIM sok AS INTEGER
  DIM fiHandle AS LONG
  DIM fstream AS QMEMORYSTREAM
  DIM buf AS STRING
  DIM pbuf AS LONG
  DIM sizebuf AS LONG
  DIM psizebuf AS LONG
    
  if qfimage.Handle then
    fiHandle = FI_OpenMemory(0,0)        'open a memory stream with FreeImage
    if fiHandle then
      sok = FI_SaveToMemory(FIF_BMP, qfimage.Handle, fiHandle, BMP_DEFAULT)  'save the bmp into memory stream
      if sok then
        buf = space$(qfimage.Size)       'tricky, a string as buffer ;-)
        pbuf = varptr(buf)               'the pointer
        sizebuf = qfimage.Size
        psizebuf = varptr(sizebuf)
        sok = FI_AcquireMemory(fiHandle, pbuf, psizebuf)  'copy the image from memory stream buffer into 'buffer'
        fstream.Size = sizebuf
        fstream.Position = 0
        fstream.MemCopyFrom(pbuf,sizebuf)  'now, from buffer into rapidq-stream
        fstream.Position = 0
        fbmp.Width = qfimage.Width
        fbmp.Height = qfimage.Height
        fbmp.LoadFromStream(fstream)       'uff, load the bmp from stream
        fstream.Close                      'close stream
        FI_CloseMemory(fiHandle)           'close the FreeImage memory stream
$ifdef _QFI_TEST
        fbmp.SaveToFile("_FI_TMP_STREAM_IMAGE_.BMP") 'this bitmap is correct!
$endif
        with src                           'here the problem begins... :(
          .Top = 0
          .Left = 0
          .Right = qfimage.Width
          .Bottom = qfimage.Height
        end with
        with dest
          .Top = 0
          .Left = 0
          .Right = qfimage.Width
          .Bottom = qfimage.Height
        end with
        qfimage.Image.Width = qfimage.Width
        qfimage.Image.Height = qfimage.Height
        qfimage.Image.CopyRect(dest,fbmp,src)  'copy from bmp to image - why only 105*105pix
        qfimage.BMP = qfimage.Image.BMP
        qfimage.GetFastImage = True            'but not the whole bitmap????
      else
        FI_CloseMemory(fiHandle)               'free memory
        qfimage.GetFastImage = False
      end if
    else        
      qfimage.GetFastImage = False
    end if
  else
    qfimage.GetFastImage = False
  end if
END FUNCTION

'SaveToFile
'Save the image into file
'File format (type) is extracted only from file extension
'The SaveOption is one of the defined open/save options and overwrite qfimage.SaveOption.
'If you wish to use the object property instead the function parameter, use FI_SAVE_PROP.
'Note that some file formats needs to convert into 8Bpp or grayscale before to save properly (GIF, IFF, WBMP...)
'Returns TRUE if OK, otherwise FALSE
FUNCTION SaveToFile(sDestFile AS STRING, iSaveOption AS INTEGER) AS INTEGER
  DIM sext AS STRING
  DIM sopt AS INTEGER
  DIM sok AS INTEGER
  DIM qft AS LONG
  
  sext = UCase$(Field$(sDestFile,".",2))
  if sext <> "" then
    select case sext
      case "BMP","DIB","RLE"
        qft = FIF_BMP
      case "JPG","JPEG","JFI","JFIF"
        qft = FIF_JPEG
      case "GIF"
        qft = FIF_GIF
      case "PNG"
        qft = FIF_PNG
      case "JNG"
        qft = FIF_JNG
      case "ICO"
        qft = FIF_ICO
      case "TGA"
        qft = FIF_TARGA
      case "TIF","TIFF"
        qft = FIF_TIFF
      case "PBM"
        qft = FIF_PBM
      case "PGM"
        qft = FIF_PGM
      case "PPM"
        qft = FIF_PPM
      case "WAP","WBMP","WBM"
        qft = FIF_WBMP
      case "XPM"
        qft = FIF_XPM
      case else
        qft = FIF_BMP
    end select
  else
    qft = FIF_BMP
  end if 
  if iSaveOption = FI_SAVE_PROP then
    sopt = qfimage.SaveOption
  else
    sopt = iSaveOption
  end if
  sok = FI_SaveImage(qft, qfimage.Handle, sDestFile, sopt)
  if sok then
    qfimage.SaveToFile = True
  else
    qfimage.SaveToFile = False
  end if
END FUNCTION

'ConvertImage
'Tell the function by option, into what you'll convert (see constants)
'Returns TRUE if OK, otherwise FALSE
FUNCTION ConvertImage(iConvOpt AS INTEGER) AS INTEGER
  DIM sok AS INTEGER
  DIM oHandle AS LONG
  
  oHandle = qfimage.Handle
  qfimage.Handle = 0
  select case iConvOpt
    case FI_CONV_GREY
      qfimage.Handle = FI_ConvToGrey(oHandle)
    case FI_CONV_4BIT
      qfimage.Handle = FI_ConvTo4Bit(oHandle)
    case FI_CONV_8BIT
      qfimage.Handle = FI_ConvTo8Bit(oHandle)
    case FI_CONV_16BIT
      qfimage.Handle = FI_ConvTo16Bit(oHandle)
    case FI_CONV_24BIT
      qfimage.Handle = FI_ConvTo24Bit(oHandle)
    case FI_CONV_32BIT
      qfimage.Handle = FI_ConvTo32Bit(oHandle)
  end select
  if qfimage.Handle then
    FI_UnloadImage(oHandle)
    qfimage.Width = FI_GetWidth(qfimage.Handle)
    qfimage.Height = FI_GetHeight(qfimage.Handle)
    qfimage.Size = FI_GetSize(qfimage.Handle)
    qfimage.Bpp = FI_GetBpp(qfimage.Handle)
    qfimage.Colors = 2^qfimage.Bpp
    qfimage.ConvertImage = True
  else
    qfimage.Handle = oHandle
    qfimage.ConvertImage = False
  end if
END FUNCTION

'ResizeImage
'Resize the Image with specified method (see filter)
'Note, that resizing needs 24Bpp images (ConvertImage())
'Returns TRUE if OK, otherwise FALSE
FUNCTION ResizeImage(iWidth AS LONG, iHeight AS LONG, iMethod AS LONG) AS INTEGER
  DIM sok AS INTEGER
  DIM oHandle AS LONG

  oHandle = qfimage.Handle
  qfimage.Handle = FI_Resize(oHandle, iWidth, iHeight, iMethod)
  if qfimage.Handle then
    FI_UnloadImage(oHandle)
    qfimage.Width = FI_GetWidth(qfimage.Handle)
    qfimage.Height = FI_GetHeight(qfimage.Handle)
    qfimage.Size = FI_GetSize(qfimage.Handle)
    qfimage.Bpp = FI_GetBpp(qfimage.Handle)
    qfimage.Colors = 2^qfimage.Bpp
    qfimage.ResizeImage = True
  else
    qfimage.Handle = oHandle
    qfimage.ResizeImage = False
  end if
END FUNCTION

'ReduceColor
'Reduce the colors of an 24bit image to 8bits (see quantize methods)
'Returns TRUE if OK, otherwise FALSE
FUNCTION ReduceColor(iMethod AS LONG) AS INTEGER
  DIM sok AS INTEGER
  DIM oHandle AS LONG
  
  oHandle = qfimage.Handle
  qfimage.Handle = FI_ReduceColor(oHandle, iMethod)
  if qfimage.Handle then
    FI_UnloadImage(oHandle)
    qfimage.Width = FI_GetWidth(qfimage.Handle)
    qfimage.Height = FI_GetHeight(qfimage.Handle)
    qfimage.Size = FI_GetSize(qfimage.Handle)
    qfimage.Bpp = FI_GetBpp(qfimage.Handle)
    qfimage.Colors = 2^qfimage.Bpp
    qfimage.ReduceColor = True
  else
    qfimage.Handle = oHandle
    qfimage.ReduceColor = False
  end if
END FUNCTION

'FlipImage
'Returns TRUE if OK, otherwise FALSE
FUNCTION FlipImage(iAxis AS INTEGER) AS INTEGER
  DIM sok AS INTEGER
  
  if iAxis = FI_FLIP_HOR then
    sok = FI_FlipHorizontal(qfimage.Handle)
  else
    sok = FI_FlipVertical(qfimage.Handle)
  end if
  if sok then
    qfimage.FlipImage = True
  else
    qfimage.FlipImage = False
  end if
END FUNCTION

'FlipHorizontal
'Returns TRUE if OK, otherwise FALSE
FUNCTION FlipHorizontal(iAxis AS INTEGER) AS INTEGER
  DIM sok AS INTEGER
  
  sok = FI_FlipHorizontal(qfimage.Handle)
  if sok then
    qfimage.FlipHorizontal = True
  else
    qfimage.FlipHorizontal = False
  end if
END FUNCTION

'FlipVertical
'Returns TRUE if OK, otherwise FALSE
FUNCTION FlipVertical(iAxis AS INTEGER) AS INTEGER
  DIM sok AS INTEGER
  
  sok = FI_FlipVertical(qfimage.Handle)
  if sok then
    qfimage.FlipVertical = True
  else
    qfimage.FlipVertical = False
  end if
END FUNCTION

'RotateImage
'Returns TRUE if OK, otherwise FALSE
FUNCTION RotateImage(dAngel AS DOUBLE) AS INTEGER
  DIM sok AS INTEGER
  DIM oHandle AS LONG
  
  oHandle = qfimage.Handle
  qfimage.Handle = FI_Rotate(oHandle, dAngel)
  if qfimage.Handle then
    FI_UnloadImage(oHandle)
    qfimage.Width = FI_GetWidth(qfimage.Handle)
    qfimage.Height = FI_GetHeight(qfimage.Handle)
    qfimage.Size = FI_GetSize(qfimage.Handle)
    qfimage.Bpp = FI_GetBpp(qfimage.Handle)
    qfimage.Colors = 2^qfimage.Bpp
    qfimage.RotateImage = True
   else
    qfimage.Handle = oHandle
    qfimage.RotateImage = False
  end if
END FUNCTION

'InvertImage
'Returns TRUE if OK, otherwise FALSE
FUNCTION InvertImage() AS INTEGER
  DIM sok AS INTEGER
  DIM oHandle AS LONG
  
  oHandle = qfimage.Handle
  qfimage.Handle = FI_Invert(oHandle)
  if qfimage.Handle then
    FI_UnloadImage(oHandle)
    qfimage.Width = FI_GetWidth(qfimage.Handle)
    qfimage.Height = FI_GetHeight(qfimage.Handle)
    qfimage.Size = FI_GetSize(qfimage.Handle)
    qfimage.Bpp = FI_GetBpp(qfimage.Handle)
    qfimage.Colors = 2^qfimage.Bpp
    qfimage.InvertImage = True
  else
    qfimage.Handle = oHandle
    qfimage.InvertImage = False
  end if
END FUNCTION

'AdjustImage
'Tell the function by adjust option, what you'll adjust...
'The second parameter depends on what will be adjust.
'Returns TRUE if OK, otherwise FALSE
FUNCTION AdjustImage(iAdjOpt AS INTEGER, dAdjPara AS DOUBLE) AS INTEGER
  DIM sok AS INTEGER
  
  sok = 1
  select case iAdjOpt
    case FI_ADJ_GAMMA
      sok = FI_AdjustGamma(qfimage.Handle, dAdjPara)
    case FI_ADJ_BRIGHT
      sok = FI_AdjustBrightness(qfimage.Handle, dAdjPara)
    case FI_ADJ_CONTRAST
      sok = FI_AdjustContrast(qfimage.Handle, dAdjPara)
    case else
      sok = 0
  end select
  if sok then
    qfimage.AdjustImage = True
  else
    qfimage.AdjustImage = False
  end if
END FUNCTION

'UnloadImage
'This unloads the FI-Image
'Ever(!) if you're ready to use the image in RapidQ, call this function to prevent memory leaks!
'After this, you can't anymore access the FI-Image - it's destroyed... ;-)
'Returns TRUE if OK, otherwise FALSE
FUNCTION UnloadImage() AS INTEGER
  qfimage.UnloadImage = FI_UnloadImage(qfimage.Handle)
END FUNCTION

'Constructor
CONSTRUCTOR
  Handle = 0
  Width = 0
  Height = 0
  Size = 0
  Bpp = 0
  Colors = 0
  Type = FIF_BMP
  TypeString = FIF_STR_BMP
  LoadOption = BMP_DEFAULT
  SaveOption = BMP_DEFAULT
END CONSTRUCTOR

END TYPE


'The Type QFGifImage
'Only for Multipage-Gif's (animated) and only read functions (exception: frame saving)!
'To determine, if your image is an animated GIF use the method .IsAnimGIF.
'
TYPE QFGifImage EXTENDS QIMAGE
private:
  Handle AS LONG
  Timer AS QTIMER
  fHandle(GIF_MAX_FRAMES) AS LONG
  Frame(GIF_MAX_FRAMES) AS QIMAGE

public:
  Filename AS STRING * 256
  Width AS INTEGER
  Height AS INTEGER
  Size AS INTEGER
  Bpp AS INTEGER
  Colors AS INTEGER
  Type AS INTEGER
  TypeString AS STRING * 40
  Loops AS INTEGER
  LoopNum AS INTEGER
  Interval AS INTEGER
  Animate AS INTEGER
  FrameCount AS INTEGER
  FrameNum AS INTEGER
  FrameLen(GIF_MAX_FRAMES) AS INTEGER


'CheckTimer
SUB CheckTimer(Sender as QTIMER)
  if qfgifimage.Animate AND qfgifimage.LoopNum >= 0 then
    qfgifimage.Timer.Enabled = 0
    qfgifimage.BMP = qfgifimage.Frame(qfgifimage.Timer.Tag).BMP
    qfgifimage.FrameNum = qfgifimage.Timer.Tag
    if qfgifimage.FrameLen(qfgifimage.FrameNum) > 0 then
      qfgifimage.Timer.Interval = qfgifimage.FrameLen(qfgifimage.FrameNum) * 10
    else
      qfgifimage.Timer.Interval = qfgifimage.Interval * 10
    end if
    qfgifimage.Timer.Tag = qfgifimage.Timer.Tag + 1
    if qfgifimage.Timer.Tag = qfgifimage.FrameCount then
      qfgifimage.Timer.Tag = 0
      qfgifimage.FrameNum = 0
      if qfgifimage.Loops > 0 then
        qfgifimage.LoopNum = qfgifimage.LoopNum + 1
        if qfgifimage.LoopNum = qfgifimage.Loops then
          qfgifimage.LoopNum = -1
        end if
      end if
    end if
    qfgifimage.Timer.Enabled = 1
  else
    qfgifimage.Timer.Enabled = 0
  end if
END SUB

'IsAniGIF
'Determine if the file is an animated GIF, ready to show with QFGifImage-Object.
'The number of frames is stored in .FrameCount
'Returns TRUE if OK, otherwise FALSE
Function IsAniGIF(sSourceFile as STRING) AS INTEGER
  
  qfgifimage.Handle = FI_OpenMultiBitmap(FIF_GIF, sSourceFile, 0, 1, 0, GIF_DEFAULT)
  if qfgifimage.Handle then
    qfgifimage.FrameCount = FI_GetPageCount(qfgifimage.Handle)
    FI_CloseMultiBitmap(qfgifimage.Handle, GIF_DEFAULT)
    if qfgifimage.FrameCount < 2 or qfgifimage.FrameCount > GIF_MAX_FRAMES then
      qfgifimage.IsAniGIF = False
    else
      qfgifimage.IsAniGIF = True
    end if
  else
    qfgifimage.IsAniGIF = False
  end if
End Function

'LoadFromFile
'Loads the GIF-File into the object
'The animation must be startet with .StartAnim
'Before you start the animation you can set the FrameLen(i) parameter (in 1/100s) for each frame,
'standard is 10 (1/10s).
'Returns TRUE if OK, otherwise FALSE
FUNCTION LoadFromFile(sSourceFile AS STRING) AS INTEGER
  DIM i AS LONG
  
  qfgifimage.Handle = FI_OpenMultiBitmap(FIF_GIF, sSourceFile, 0, 1, 0, GIF_DEFAULT)
  if qfgifimage.Handle then
    qfgifimage.FrameCount = FI_GetPageCount(qfgifimage.Handle)
    if qfgifimage.FrameCount < 2 or qfgifimage.FrameCount > GIF_MAX_FRAMES then
      FI_CloseMultiBitmap(qfgifimage.Handle, GIF_DEFAULT)
      qfgifimage.FrameCount = 0
      qfgifimage.Handle = 0
      qfgifimage.LoadFromFile = False
    else
      qfgifimage.Filename = sSourceFile
      qfgifimage.Size = 0
      for i = 0 to qfgifimage.FrameCount - 1
        qfgifimage.FrameLen(i) = 0
        qfgifimage.fHandle(i) = FI_LockPage(qfgifimage.Handle, i)
        FI_SaveImage(FIF_BMP, qfgifimage.fHandle(i), "_FI_TMP_GIF_FRAME" + format$("%3.3d",i) + ".BMP", BMP_DEFAULT)
        qfgifimage.Frame(i).Autosize = 1
        qfgifimage.Frame(i).BMP = "_FI_TMP_GIF_FRAME" + format$("%3.3d",i) + ".BMP"
        qfgifimage.BMP = qfgifimage.Frame(0).BMP
        qfgifimage.Size = qfgifimage.Size + FI_GetSize(qfgifimage.fHandle(i))
        FI_UnlockPage(qfgifimage.Handle, qfgifimage.fHandle(i), 0)
      next
      FI_CloseMultiBitmap(qfgifimage.Handle, GIF_DEFAULT)
      qfgifimage.Width = qfgifimage.Frame(0).Width
      qfgifimage.Height = qfgifimage.Frame(0).Height
      qfgifimage.Bpp = 8
      qfgifimage.Colors = 256
      qfgifimage.Type = FIF_GIF
      qfgifimage.TypeString = "Animated GIF"
      qfgifimage.LoadFromFile = True
$ifndef _QFI_TEST
      for i = 0 to qfgifimage.FrameCount - 1
        Kill("_FI_TMP_GIF_FRAME" + format$("%3.3d",i) + ".BMP")
      next
$endif
      qfgifimage.Animate = 0
      qfgifimage.FrameNum = 0
      qfgifimage.Loops = 0
      qfgifimage.LoopNum = 0
      qfgifimage.Timer.Interval = 100
      qfgifimage.Timer.Tag = 0
      qfgifimage.Timer.Enabled = 0
    end if
  else
    qfgifimage.LoadFromFile = False
  end if
END FUNCTION

'StartAnim
'Starts the animation at specified frame number
'The actual frame number is stored in .FrameNum
SUB StartAnim(iFrame)
  qfgifimage.BMP = qfgifimage.Frame(iFrame).BMP
  qfgifimage.Width = qfgifimage.Frame(0).Width
  qfgifimage.Height = qfgifimage.Frame(0).Height
  qfgifimage.Timer.Tag = iFrame
  qfgifimage.FrameNum = iFrame
  if qfgifimage.FrameLen(qfgifimage.FrameNum) > 0 then
    qfgifimage.Timer.Interval = qfgifimage.FrameLen(qfgifimage.FrameNum) * 10
  else
    qfgifimage.Timer.Interval = qfgifimage.Interval * 10
  end if
  qfgifimage.Timer.Enabled = 1
  qfgifimage.Animate = 1
  qfgifimage.LoopNum = 0
END SUB

'StopAnim
SUB StopAnim
  qfgifimage.Timer.Enabled = 0
  qfgifimage.Animate = 0
END SUB

'SaveFrames
'Saving the frames of the GIF-File into Files with 'FileName + _FrameXX.bmp'
'The FileName property must be set and a GIF must be loaded ;-)
SUB SaveFrames
  DIM i AS INTEGER
  DIM fbmp AS QBITMAP
  DIM src AS QRECT
  DIM dest AS QRECT
  DIM outf AS STRING
  
  outf = Field$(qfgifimage.FileName,".",1) + "_Frame"
  for i = 0 to qfgifimage.FrameCount - 1
    fbmp.Width = qfgifimage.Frame(i).Width
    fbmp.Height = qfgifimage.Frame(i).Height
    with src
      .Top = 0
      .Left = 0
      .Right = fbmp.Width
      .Bottom = fbmp.Height
    end with
    with dest
      .Top = 0
      .Left = 0
      .Right = fbmp.Width
      .Bottom = fbmp.Height
    end with
    fbmp.CopyRect(dest,qfgifimage.Frame(i),src)
    fbmp.SaveToFile(outf + format$("%3.3d",i) + ".bmp")
  next
END SUB


'Constructor
CONSTRUCTOR
  FileName = ""
  Handle = 0
  Timer.Interval = 100
  Timer.Enabled = 0
  Timer.OnTimer = qfgifimage.CheckTimer
  Width = 0
  Height = 0
  Size = 0
  Bpp = 0
  Colors = 0
  Type = FIF_GIF
  TypeString = FIF_STR_GIF
  Loops = 0
  LoopNum = 0
  Interval = 10
  Animate = 1
  FrameCount = 0
  FrameNum = 0
END CONSTRUCTOR

END TYPE


'<EOF>
